﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using System.Collections.Generic;
using System.Linq;
using XamListApp.INETAService;

namespace XamListApp
{
    public class GroupingProvider : IGroupingProvider
    {
        public System.Collections.Generic.List<string> GetAllGroupNames()
        {
            var titles = (from grp in App.GroupModel.Groups
                          select grp.Name).ToList();
            return titles;
        }

        public string GetGroupNameForItem(object item)
        {
            var Id = App.ViewModel.Authors.Where(a => a.AuthorID == (int)item).FirstOrDefault().LivePresentations
                .GroupBy(p => p.GroupID)
                .Select(p => new { ID = p.Key, num = p.Count() })
                .OrderByDescending(p => p.num)
                .First().ID;
            var name = App.GroupModel.Groups.Where(x => x.GroupID == Id).FirstOrDefault().Name;
            return name;
        }
    }
}

