﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Infragistics.Controls.Grids;
using System.Windows.Data;
using XamListApp.INETAService;
using Microsoft.Phone.Shell;

namespace XamListApp
{
    public partial class PageTwo : PhoneApplicationPage
    {
        // Constructor
        public PageTwo()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(PageTwo_Loaded);
        }

       

        // Load data for the ViewModel Items
        private void PageTwo_Loaded(object sender, RoutedEventArgs e)
        {
            if (!App.ViewModel.IsDataLoaded)
            {
                App.ViewModel.LoadData();
                App.ViewModel.Authors.LoadCompleted += new EventHandler<System.Data.Services.Client.LoadCompletedEventArgs>(Authors_LoadCompleted);
                progress.Visibility = Visibility.Visible;
            }
            else
            {
                this.xamListQuick.DataContext = App.ViewModel;
            }
            //show loading animation and set context to the List
        }
        
        void Authors_LoadCompleted(object sender, System.Data.Services.Client.LoadCompletedEventArgs e)
        {
            this.xamListQuick.DataContext = App.ViewModel;
            App.ViewModel.Authors.LoadCompleted -= new EventHandler<System.Data.Services.Client.LoadCompletedEventArgs>(Authors_LoadCompleted);
            progress.Visibility = Visibility.Collapsed;
            ContentPanel.Children.Remove(progress);
        }

        private void xamList_ItemClicked(object sender, ListItemEventArgs e)
        {
            if (e.Item.Data is LiveAuthor)
            {
                LiveAuthor clicked = (LiveAuthor)e.Item.Data;
                this.PageTitle.Text = clicked.FirstName + " " + clicked.LastName;
            }
        }
        
        private void xamList_GotFocus(object sender, RoutedEventArgs e)
        {
            if (e.OriginalSource is ScrollViewer && (sender as XamList).ItemsSource is IEnumerable<LiveAuthor>)
            {
                this.PageTitle.Text = "authors";
            }
        }
    }
}