﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Data.Services.Client;
using XamListApp.INETAService;
using System.Linq;


namespace XamListApp
{
    public class GroupsModel : INotifyPropertyChanged
    {
        public GroupsModel()
        {
            this.Groups = new DataServiceCollection<LiveGroup>();
        }

        INETALivePublic context;

        private DataServiceCollection<LiveGroup> groups;

        public DataServiceCollection<LiveGroup> Groups
        {
            get { return groups; }
            set
            {
                groups = value;
                groups.LoadCompleted += new EventHandler<LoadCompletedEventArgs>(authors_LoadCompleted);
                NotifyPropertyChanged("Authors");
            }
        }

        public bool IsDataLoaded { get; private set; }

        /// <summary>
        /// Load data.
        /// </summary>
        public void LoadData()
        {
            context = new INETALivePublic(new Uri("http://live.ineta.org/InetaLiveService.svc/"));
            Groups = new DataServiceCollection<LiveGroup>(context);
            var query = from grps in context.LiveGroups.Expand("LivePresentations") select grps;
            var test = query.ToString();
            Groups.LoadAsync(query);
        }

        void authors_LoadCompleted(object sender, LoadCompletedEventArgs e)
        {
            if (Groups.Continuation != null)
            {
                Groups.LoadNextPartialSetAsync();
            }
            IsDataLoaded = true;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}